using System;
using System.CodeDom;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms.VisualStyles;
using ff14bot;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Objects;
using ff14bot.Helpers;
using Kupper;
using Kupper.Helpers;
using Kupper.Settings;
using Pathfinding;
using TreeSharp;
using Action = TreeSharp.Action;

namespace Kupper.Rotations
{
    public class Ninja : KupperRoutine
    {
        //DEVELOPERS REPLACE GetType().Name WITH YOUR CR'S NAME.
        public override string Name
        {
            get { return "Kupper [" + GetType().Name + "]"; }
        }
		
		public override void OnInitialize()
        {
            WindowSettings = new NinjaSettings();
			Kupper.Settings.NinjaSettings.MudraState = "Ninjutsu";
			Kupper.Settings.NinjaSettings.lastspellused = "Ninjutsu";
        }

        private NinjaSettings settings
        {
            get { return WindowSettings as NinjaSettings; }
        }

        public override float PullRange
        {
            get { return 3; }
        }

        public override ClassJobType[] Class
        {
            get { return new ClassJobType[] {ClassJobType.Ninja}; }
        }

		public SpellData SkillBlocker;
		public SpellData SATATimer;
		public SpellData NinjutsuTimer;
		
		public override void OnPulse()
        {
			if(	
			Actionmanager.LastSpell.Name == "Mutilate" ||
			Actionmanager.LastSpell.Name == "Spinning Edge" ||
			Actionmanager.LastSpell.Name == "Gust Slash" ||
			Actionmanager.LastSpell.Name == "Shadow Fang" ||
			Actionmanager.LastSpell.Name == "Dancing Edge" ||
			Actionmanager.LastSpell.Name == "Aeolian Edge" ||
			Actionmanager.LastSpell.Name == "EmptySpell")
			Kupper.Settings.NinjaSettings.ComboState = Actionmanager.LastSpell.Name;
			
		Actionmanager.CurrentActions.TryGetValue("Spinning Edge", out SkillBlocker);
		Actionmanager.CurrentActions.TryGetValue("Sneak Attack", out SATATimer);
		Actionmanager.CurrentActions.TryGetValue("Ten", out NinjutsuTimer);
		Logging.Write("Ninjutsu Cooldown = " + NinjutsuTimer.Cooldown.TotalMilliseconds);
		Logging.Write("lastspellused = " + Kupper.Settings.NinjaSettings.lastspellused);
		Logging.Write("MudraState = " + Kupper.Settings.NinjaSettings.MudraState);
//		Logging.Write("Skillblocker = " + SkillBlocker.Cooldown.TotalMilliseconds);
		
			if(NinjutsuTimer.Cooldown.TotalMilliseconds >= 1)
			Kupper.Settings.NinjaSettings.MudraState = Kupper.Settings.NinjaSettings.lastspellused;
			if(NinjutsuTimer.Cooldown.TotalMilliseconds >= 550){
				Kupper.Settings.NinjaSettings.MudraState = "Ninjutsu";
				Kupper.Settings.NinjaSettings.lastspellused = "Ninjutsu";
			}
//			if(NinjutsuTimer.Cooldown.TotalMilliseconds == 0 && !Core.Player.HasAura("Mudra")){
//				Kupper.Settings.NinjaSettings.MudraState = "Ninjutsu";
//				Kupper.Settings.NinjaSettings.lastspellused = "Ninjutsu";
//			}
        }

        [Behavior(BehaviorType.PreCombatBuffs)]
        public Composite CreateBasicPreCombatBuffs()
        {
            return SummonChocobo();
        }

        [Behavior(BehaviorType.Rest)]
        public Composite CreateBasicRest()
        {
            return DefaultRestBehavior(r => Core.Player.CurrentTPPercent);
        }

        [Behavior(BehaviorType.Pull)]
        public Composite CreateBasicPull()
        {
            return new PrioritySelector(

				//SATA
				new Decorator(r =>
				
					Core.Player.HasAura("Hidden") ||
					Core.Player.HasAura("Suiton"),
				
					new PrioritySelector(
						Spell.Cast("Trick Attack", r => Core.Player.CurrentTarget.IsBehind && settings.UseTrickAttack),
						Spell.Cast("Sneak Attack", r => !Core.Player.CurrentTarget.IsBehind && !Core.Player.CurrentTarget.IsFlanking && settings.UseSneakAttack)
						)
					),
					
				//Kassatsu
				new Decorator(
					new PrioritySelector(
						Spell.Cast(r => "Kassatsu", r => NinjutsuTimer.Cooldown.TotalMilliseconds >= 2000 && settings.UseKassatsu, r => Core.Player)
						)
					),

				
				//Huton
				new Decorator(r =>
				
					!Core.Player.HasAura("Huton", true, 3000) &&
					Actionmanager.HasSpell("Jin") &&
					settings.UseHuton
					,
					new PrioritySelector(
						Spell.Cast(r => "Jin", r => Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu", r => Core.Player),
						Spell.Cast(r => "Chi", r => Kupper.Settings.NinjaSettings.MudraState == "Jin", r => Core.Player),
						Spell.Cast(r => "Ten", r => Kupper.Settings.NinjaSettings.MudraState == "Chi", r => Core.Player),
						Spell.Cast(r => "Ninjutsu", r => Actionmanager.CanCast("Ninjutsu", Core.Player) && Kupper.Settings.NinjaSettings.MudraState == "Ten", r => Core.Player.CurrentTarget, true)
						)
					),
				
				//Suiton
				
				new Decorator(r =>
				
					Actionmanager.HasSpell("Jin") &&
					SATATimer.Cooldown.TotalMilliseconds <= 1000 &&
					settings.UseSuiton
					,
					new PrioritySelector(
						Spell.Cast(r => "Ten", r => Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu" && Core.Player.HasAura("Huton", true, 30000), r => Core.Player),
						Spell.Cast(r => "Chi", r => Kupper.Settings.NinjaSettings.MudraState == "Ten" && Core.Player.HasAura("Huton", true, 25000), r => Core.Player),
						Spell.Cast(r => "Jin", r => Kupper.Settings.NinjaSettings.MudraState == "Chi" && Core.Player.HasAura("Huton", true, 20000), r => Core.Player),
						Spell.Cast(r => "Ninjutsu", r => Actionmanager.CanCast("Ninjutsu", Core.Player) && Kupper.Settings.NinjaSettings.MudraState == "Jin", r => Core.Player.CurrentTarget, true)
						)
					),
				
				//Raiton
				new Decorator(r => 
					(Core.Player.HasAura("Huton", true, 30000) || !Actionmanager.HasSpell("Jin")) &&
					settings.UseRaiton
					,
					new PrioritySelector(
						Spell.Cast(r => "Ten", r => Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu", r => Core.Player),
						Spell.Cast(r => "Chi", r => Kupper.Settings.NinjaSettings.MudraState == "Ten", r => Core.Player),
						Spell.Cast(r => "Ninjutsu", r => Actionmanager.CanCast("Ninjutsu", Core.Player) && Kupper.Settings.NinjaSettings.MudraState == "Chi", r => Core.Player.CurrentTarget, true)
						)
					),
					
				
				
				//Fuma Shuriken
				new Decorator(r => 
					(!Actionmanager.HasSpell("Chi") && settings.UseFumaShuriken) ||
					(!settings.UseRaiton && settings.UseFumaShuriken)
					,
					new PrioritySelector(
						Spell.Cast(r => "Ten", r => Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu", r => Core.Player),
						Spell.Cast(r => "Ninjutsu", r => Actionmanager.CanCast("Ninjutsu", Core.Player) && Kupper.Settings.NinjaSettings.MudraState == "Ten", r => Core.Player.CurrentTarget, true)
						)
					),
		
				//Buffs
				new Decorator(r => 
					Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu" &&
					settings.UseBuffs && 
					Core.Player.CurrentTarget.CurrentHealth >= settings.BuffHPLimit && 
					SkillBlocker.Cooldown.TotalMilliseconds >= 1000, 
					
					new PrioritySelector(
						Spell.Cast("Kiss of the Wasp", r => !Core.Player.HasAura("Kiss of the Wasp") && ((settings.UseWasp && !settings.UseViper) || (settings.UseWasp && !Actionmanager.HasSpell("Kiss of the Viper"))), r => Core.Player),
						Spell.Cast("Kiss of the Viper", r => !Core.Player.HasAura("Kiss of the Viper") && settings.UseViper, r => Core.Player),
						Spell.Cast("Blood for Blood", r => !Core.Player.HasAura("Blood for Blood") && settings.UseBloodForBlood, r => Core.Player),
						Spell.Cast("Internal Release", r => !Core.Player.HasAura("Internal Release") && settings.UseInternalRelease, r => Core.Player)
						)
					),

				//GCDs / Main Combo
				new Decorator(r => Core.Player.CurrentTarget != Core.Player && Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu",			
					new PrioritySelector(
						Spell.Cast("Mutilate", r => 
							(!Core.Player.CurrentTarget.HasAura("Mutilation", true, 2000) && Core.Player.CurrentTarget.CurrentHealth >= settings.DOTLimit) && 
								(
								(Kupper.Settings.NinjaSettings.ComboState == "Spinning Edge" && !Actionmanager.HasSpell("Gust Slash")) ||
								(Kupper.Settings.NinjaSettings.ComboState == "Gust Slash" && !Actionmanager.HasSpell("Aeolian Edge")) ||
								(Kupper.Settings.NinjaSettings.ComboState == "Shadow Fang") ||
								(Kupper.Settings.NinjaSettings.ComboState == "Aeolian Edge") ||
								(Kupper.Settings.NinjaSettings.ComboState == "Dancing Edge") ||
								(Kupper.Settings.NinjaSettings.ComboState == "Mutilate") ||
								(Kupper.Settings.NinjaSettings.ComboState == "EmptySpell")
								)),							
						Spell.Cast("Dancing Edge", r => 
							Kupper.Settings.NinjaSettings.ComboState == "Gust Slash" && 
							(!Core.Player.CurrentTarget.HasAura("Dancing Edge", false, 2000) &&	!Core.Player.CurrentTarget.HasAura("Storm's Eye", false)) && 
							settings.UseDancingEdge),
						Spell.Cast("Aeolian Edge", r => Kupper.Settings.NinjaSettings.ComboState == "Gust Slash"),
						Spell.Cast("Shadow Fang", r => Kupper.Settings.NinjaSettings.ComboState == "Spinning Edge" && !Core.Player.CurrentTarget.HasAura("Shadow Fang", true, 3000) && Core.Player.CurrentTarget.CurrentHealth >= settings.DOTLimit),
						Spell.Cast("Gust Slash", r => Kupper.Settings.NinjaSettings.ComboState == "Spinning Edge"),
						Spell.Cast("Spinning Edge")
						)
					),
					
				//Defensives
				new Decorator(r => 
					Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu" &&
					(SkillBlocker.Cooldown.TotalMilliseconds >= 1000 ||	Core.Player.CurrentTP <= 50), 
					
					new PrioritySelector(
						Spell.Cast("Invigorate", r => Core.Player.CurrentTPPercent <= settings.UseInvigorateTP, r => Core.Player),
						Spell.Cast("Second Wind", r => Core.Player.CurrentHealthPercent <= settings.UseSecondWindHP, r => Core.Player),
						Spell.Cast("Featherfoot", r => Core.Player.CurrentHealthPercent <= settings.UseFeatherfootHP, r => Core.Player)
						)
					),
				
				//OffGCDs
				new Decorator(r => 
				
					SkillBlocker.Cooldown.TotalMilliseconds >= 1000	&& 
					Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu",	
										
					new PrioritySelector(
						Spell.Cast("Assassinate"),
						Spell.Cast("Mug"),
						Spell.Cast("Jugulate")
						)
					)
			);
					
        }
		

        [Behavior(BehaviorType.Combat)]
        public Composite CreateBasicCombat()
        {
            return new PrioritySelector(ctx => Core.Player.CurrentTarget as BattleCharacter,
                new Decorator(r => BotManager.Current.IsAutonomous, new PrioritySelector(
					CommonBehaviors.MoveToLos(ctx => ctx as GameObject),
					CommonBehaviors.MoveAndStop(ctx => (ctx as GameObject).Location, ctx => 24, true, "Moving to unit")
						)
					),

				//SATA
				new Decorator(r =>
				
					Core.Player.HasAura("Hidden") ||
					Core.Player.HasAura("Suiton"),
				
					new PrioritySelector(
						Spell.Cast("Trick Attack", r => Core.Player.CurrentTarget.IsBehind && settings.UseTrickAttack),
						Spell.Cast("Sneak Attack", r => !Core.Player.CurrentTarget.IsBehind && !Core.Player.CurrentTarget.IsFlanking && settings.UseSneakAttack)
						)
					),
					
				//Kassatsu
				new Decorator(
					new PrioritySelector(
						Spell.Cast(r => "Kassatsu", r => NinjutsuTimer.Cooldown.TotalMilliseconds >= 2000 && settings.UseKassatsu, r => Core.Player)
						)
					),

				
				//Huton
				new Decorator(r =>
				
					!Core.Player.HasAura("Huton") &&
					(Actionmanager.HasSpell("Chi") && Actionmanager.HasSpell("Jin")) &&
					settings.UseHuton
					,
					new PrioritySelector(
						Spell.Cast(r => "Jin", r => Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu", r => Core.Player),
						Spell.Cast(r => "Chi", r => Kupper.Settings.NinjaSettings.MudraState == "Jin", r => Core.Player),
						Spell.Cast(r => "Ten", r => Kupper.Settings.NinjaSettings.MudraState == "Chi", r => Core.Player),
						Spell.Cast(r => "Ninjutsu", r => Actionmanager.CanCast("Ninjutsu", Core.Player) && Kupper.Settings.NinjaSettings.MudraState == "Ten", r => Core.Player.CurrentTarget, true)
						)
					),
				
				//Suiton
				
				new Decorator(r =>
				
					(Actionmanager.HasSpell("Chi") && Actionmanager.HasSpell("Jin")) &&
					SATATimer.Cooldown.TotalMilliseconds <= 1000 &&
					settings.UseSuiton
					,
					new PrioritySelector(
						Spell.Cast(r => "Ten", r => Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu" && Core.Player.HasAura("Huton", true, 30000), r => Core.Player),
						Spell.Cast(r => "Chi", r => Kupper.Settings.NinjaSettings.MudraState == "Ten" && Core.Player.HasAura("Huton", true, 25000), r => Core.Player),
						Spell.Cast(r => "Jin", r => Kupper.Settings.NinjaSettings.MudraState == "Chi" && Core.Player.HasAura("Huton", true, 20000), r => Core.Player),
						Spell.Cast(r => "Ninjutsu", r => Actionmanager.CanCast("Ninjutsu", Core.Player) && Kupper.Settings.NinjaSettings.MudraState == "Jin", r => Core.Player.CurrentTarget, true)
						)
					),
				
				//Raiton
				new Decorator(r => 
					(Core.Player.HasAura("Huton", true, 30000) || !Actionmanager.HasSpell("Jin")) &&
					settings.UseRaiton
					,
					new PrioritySelector(
						Spell.Cast(r => "Ten", r => Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu", r => Core.Player),
						Spell.Cast(r => "Chi", r => Kupper.Settings.NinjaSettings.MudraState == "Ten", r => Core.Player),
						Spell.Cast(r => "Ninjutsu", r => Actionmanager.CanCast("Ninjutsu", Core.Player) && Kupper.Settings.NinjaSettings.MudraState == "Chi", r => Core.Player.CurrentTarget, true)
						)
					),
					
				
				
				//Fuma Shuriken
				new Decorator(r => 
					(!Actionmanager.HasSpell("Chi") && settings.UseFumaShuriken) ||
					(!settings.UseRaiton && settings.UseFumaShuriken)
					,
					new PrioritySelector(
						Spell.Cast(r => "Ten", r => Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu", r => Core.Player),
						Spell.Cast(r => "Ninjutsu", r => Actionmanager.CanCast("Ninjutsu", Core.Player) && Kupper.Settings.NinjaSettings.MudraState == "Ten", r => Core.Player.CurrentTarget, true)
						)
					),
						
				//Buffs
				new Decorator(r => 
					Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu" &&
					settings.UseBuffs && 
					Core.Player.CurrentTarget.CurrentHealth >= settings.BuffHPLimit && 
					SkillBlocker.Cooldown.TotalMilliseconds >= 1000, 
					
					new PrioritySelector(
						Spell.Cast("Kiss of the Wasp", r => !Core.Player.HasAura("Kiss of the Wasp") && ((settings.UseWasp && !settings.UseViper) || (settings.UseWasp && !Actionmanager.HasSpell("Kiss of the Viper"))), r => Core.Player),
						Spell.Cast("Kiss of the Viper", r => !Core.Player.HasAura("Kiss of the Viper") && settings.UseViper, r => Core.Player),
						Spell.Cast("Blood for Blood", r => !Core.Player.HasAura("Blood for Blood") && settings.UseBloodForBlood, r => Core.Player),
						Spell.Cast("Internal Release", r => !Core.Player.HasAura("Internal Release") && settings.UseInternalRelease, r => Core.Player)
						)
					),

				//GCDs / Main Combo
				new Decorator(r => Core.Player.CurrentTarget != Core.Player && Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu",			
					new PrioritySelector(
						Spell.Cast("Mutilate", r => 
							(!Core.Player.CurrentTarget.HasAura("Mutilation", true, 2000) && Core.Player.CurrentTarget.CurrentHealth >= settings.DOTLimit) && 
								(
								(Kupper.Settings.NinjaSettings.ComboState == "Spinning Edge" && !Actionmanager.HasSpell("Gust Slash")) ||
								(Kupper.Settings.NinjaSettings.ComboState == "Gust Slash" && !Actionmanager.HasSpell("Aeolian Edge")) ||
								(Kupper.Settings.NinjaSettings.ComboState == "Shadow Fang") ||
								(Kupper.Settings.NinjaSettings.ComboState == "Aeolian Edge") ||
								(Kupper.Settings.NinjaSettings.ComboState == "Dancing Edge") ||
								(Kupper.Settings.NinjaSettings.ComboState == "Mutilate") ||
								(Kupper.Settings.NinjaSettings.ComboState == "EmptySpell")
								)),							
						Spell.Cast("Dancing Edge", r => 
							Kupper.Settings.NinjaSettings.ComboState == "Gust Slash" && 
							(!Core.Player.CurrentTarget.HasAura("Dancing Edge", false, 2000) &&	!Core.Player.CurrentTarget.HasAura("Storm's Eye", false)) && 
							settings.UseDancingEdge),
						Spell.Cast("Aeolian Edge", r => Kupper.Settings.NinjaSettings.ComboState == "Gust Slash"),
						Spell.Cast("Shadow Fang", r => Kupper.Settings.NinjaSettings.ComboState == "Spinning Edge" && !Core.Player.CurrentTarget.HasAura("Shadow Fang", true, 3000) && Core.Player.CurrentTarget.CurrentHealth >= settings.DOTLimit),
						Spell.Cast("Gust Slash", r => Kupper.Settings.NinjaSettings.ComboState == "Spinning Edge"),
						Spell.Cast("Spinning Edge")
						)
					),
					
				//Defensives
				new Decorator(r => 
					Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu" &&
					(SkillBlocker.Cooldown.TotalMilliseconds >= 1000 ||	Core.Player.CurrentTP <= 50), 
					
					new PrioritySelector(
						Spell.Cast("Invigorate", r => Core.Player.CurrentTPPercent <= settings.UseInvigorateTP, r => Core.Player),
						Spell.Cast("Second Wind", r => Core.Player.CurrentHealthPercent <= settings.UseSecondWindHP, r => Core.Player),
						Spell.Cast("Featherfoot", r => Core.Player.CurrentHealthPercent <= settings.UseFeatherfootHP, r => Core.Player)
						)
					),
				
				//OffGCDs
				new Decorator(r => 
				
					SkillBlocker.Cooldown.TotalMilliseconds >= 1000	&& 
					Kupper.Settings.NinjaSettings.MudraState == "Ninjutsu",	
										
					new PrioritySelector(
						Spell.Cast("Assassinate"),
						Spell.Cast("Mug"),
						Spell.Cast("Jugulate")
						)
					)
			);
        }
    }
}